/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
 
#ifndef ABOUTDIALOG_H
#define ABOUTDIALOG_H
 #include <qtextcodec.h>
#include <qvariant.h>
#include <qdialog.h>
 #include <qdir.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qtextbrowser.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QTabWidget;
class QWidget;
class QTextBrowser;
class QPushButton;

class Aboutdialog : public QDialog
{
    Q_OBJECT

public:
    Aboutdialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~Aboutdialog();

    QTabWidget* tabWidget;
    QWidget* Widget8;
    QTextBrowser* textBrowser13;
    QWidget* Widget9;
    QTextBrowser* textBrowser14;
    QWidget* TabPage;
    QTextBrowser* textBrowser15;
    QPushButton* buttonCancel;

protected:
    QVBoxLayout* AboutdialogLayout;
    QVBoxLayout* Widget8Layout;
    QVBoxLayout* Widget9Layout;
    QVBoxLayout* TabPageLayout;
    QHBoxLayout* Layout1;
    QSpacerItem* Horizontal_Spacing2;

protected slots:
    virtual void languageChange();

};

#endif // ABOUTDIALOG_H

//no new line?


 