/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "bmainwindow.h"
#include <stdio.h>
#include <iostream>

using namespace std;

Mainwindowb::Mainwindowb( QWidget *parent, const char *name )
        : QTabWidget( parent, name )
{
QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
QString staba,stabb,stabc,stabd;
staba.append(appBaseDir);
stabb.append(appBaseDir);
stabc.append(appBaseDir);
stabd.append(appBaseDir);
staba.append("pictures/taba.png");
stabb.append("pictures/tabb.png");
stabc.append("pictures/tabc.png");
stabd.append("pictures/tabd.png");

QIconSet qiconseta;
qiconseta.setPixmap(staba, QIconSet::Automatic,QIconSet::Normal,QIconSet::Off);
QIconSet qiconsetb;
qiconsetb.setPixmap(stabb, QIconSet::Automatic,QIconSet::Normal,QIconSet::Off);
QIconSet qiconsetc;
qiconsetc.setPixmap(stabc, QIconSet::Automatic,QIconSet::Normal,QIconSet::Off);
QIconSet qiconsetd;
qiconsetd.setPixmap(stabd, QIconSet::Automatic,QIconSet::Normal,QIconSet::Off);

widgeta = new bWidgeta(this, "Animatie 1");
widgetb = new bWidgetb(this, "Animatie 2");
//widgetc = new bWidgetc(this, "Theorie");
theoryb = new Theory(this, "theoryb","_dubbelverhoudingen_");
//widgetd = new bWidgetd(this, "Oefeningen");
exerciceb = new Exercices (this, "exercicec", "_dubbelverhouding_",2);

taba = new QTab();
tabb = new QTab();
tabc = new QTab();
tabd =  new QTab();

taba->setText(tr("Animation: Points"));
addTab(widgeta,taba);
taba->setIconSet(qiconseta);

tabb->setText(tr("Animation: lines"));
addTab(widgetb,tabb);
tabb->setIconSet(qiconsetb);

addTab(theoryb,tabc);
tabc->setText(tr("Theory"));
tabc->setIconSet(qiconsetc);

addTab(exerciceb,tabd);
tabd->setText(tr("Exercices"));
tabd->setIconSet(qiconsetd);

setMargin(0);
}

Mainwindowb::~Mainwindowb()
{

}

void Mainwindowb::makegrid()
{
	grid = new QGridLayout( this, 1, 2, 10, -1, "grid");
	buttons = new QVBoxLayout;
	tabs = new QVBoxLayout;
	
}

void Mainwindowb::addlayouts()
{
  grid->addLayout( buttons, 0, 0 );
  grid->addLayout( tabs, 0, 1 );
}

void Mainwindowb::allesingrid()
{
  grid->setColStretch( 2, 10 );
}


