#ifndef BMAINWINDOW_H
#define  BMAINWINDOW_H

/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "bwidgeta.h"
#include "bwidgetb.h"
#include "theory.h"
#include "exercices.h"
#include <qiconset.h> 

#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>
class Mainwindowb: public QTabWidget
{
	Q_OBJECT
public:
	Mainwindowb( QWidget *parent, const char *name);	
	~Mainwindowb();
	
	QGridLayout *grid;
	QVBoxLayout *buttons;
	QVBoxLayout *tabs;
	
	QTab *taba;
	QTab *tabb;
	QTab *tabc;
	QTab *tabd;
	bWidgeta *widgeta;
	bWidgetb *widgetb;
	//bWidgetc *widgetc;
	Theory *theoryb;
	//bWidgetd *widgetd;
	Exercices *exerciceb;
	
	void makegrid();
	void addlayouts();
	void allesingrid();
	
public slots:


};
#endif // BMAINWINDOW_H
