#ifndef BWIDGETA_H
#define  BWIDGETA_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qfont.h>
#include <qlayout.h>
#include <qcanvas.h>
#include <qcolor.h> 
#include <qlabel.h> 
#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
#include "displaycanvasview.h"

class bWidgeta: public QWidget
{
	Q_OBJECT
public:
	bWidgeta( QWidget *parent, const char *name);
	~bWidgeta();
	
private:
	int number;
	double dubbelverhouding;
	void setstandardsa(); //zet standaard values
	/*void makebuttons();*/ //buttons worden er aangemaakt en geconnect!
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void  makepoints();
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	void makelines(); //maak de lijnen
	void drawscale(int lengte);
	void calculate();

	QGridLayout *grid;
	QGridLayout *gridinframeleft;
	
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	QHBoxLayout *bovenaan;
	//QHBoxLayout *onderaan;
	
	QCanvas *can;
    	DisplayCanvasView *canview;
//     	QPushButton *quit;
	
	QTextBrowser *tekstinfo;
	
	QCanvasLine *xas;
	
	QCanvasEllipse *pointa;
	QCanvasEllipse *pointb;
	QCanvasEllipse *pointc;
	QCanvasEllipse *pointd;
	
	QLabel *labeldubbelverhoudinga;
	QLabel *labeldubbelverhoudingb;
	
	QCanvasLine *line;
	QCanvasText *label;
	QCanvasText *labela;
	QCanvasText *labelb;
	QCanvasText *labelc;
	QCanvasText *labeld;
protected:
QMouseEvent  *mouseevent;
	
public slots:
	void doupdate();
//	void tostart();
};
#endif //BWIDGETA_H
