/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 #ifndef DISPLAYCANVASVIEW_H
#define DISPLAYCANVASVIEW_H
 #include <stdio.h>
#include <iostream>

using namespace std;

#include <qcanvas.h>


 class DisplayCanvasView : public QCanvasView
{
  Q_OBJECT
public:
        DisplayCanvasView(  QCanvas * canvas=0, QWidget* parent = 0, const char* name = 0, WFlags f  = 0);
virtual	~DisplayCanvasView();
// 	QMessageBox *qmessagebox;		
protected:
	void contentsMousePressEvent ( QMouseEvent * e );
	void mouseReleaseEvent ( QMouseEvent *f );
	void mouseMoveEvent ( QMouseEvent *q );
			
public:
	int getX();
	int getXUnMod();
	int getY();
	int getmovingX();
	int getmovingY();
	
private:
	int x,y,a,b;
	double jos;
	
signals:
void ClickValueChanged();
//void valueYChanged( int );
void MouseMoves();
void MouseReleased();
};

#endif // f DISPLAYCANVASVIEW_H

