/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dwidgeta.h"
#include <stdio.h>
#include <iostream>

using namespace std;

dWidgeta::dWidgeta( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	this->setFont(QFont( "Bitstream Vera Sans", 12, QFont::Normal));
	setstandards();
	makecanvas();
	makebuttons();
	makegrid();
	addlayouts();
	maketekstinfo();
	allesingrid();	  
	updatecanvas();
	
}

dWidgeta::~dWidgeta()
{}

void dWidgeta::setstandards()
{
number = 0;
}

void dWidgeta::tostart()
{
if (number != 0) {
stopthetimer();
number=5;
updatecanvas(); }
}

void dWidgeta::next()
{	
	number++;updatecanvas();
}

void dWidgeta::makeobjects()
{

routeaa = new QCanvasLine(can); 
routeab = new QCanvasLine(can);
routeac = new QCanvasLine(can);
routead = new QCanvasLine(can);
routeba = new QCanvasLine(can);
routebb = new QCanvasLine(can);
routebc = new QCanvasLine(can);
routeca = new QCanvasLine(can);

routeab->setZ(1);routebc->setZ(1);
routeaa->setZ(2);
routeaa->setPen(QPen(red,5,PenStyle(DashLine)));
routeab->setPen(QPen(red,5,PenStyle(DashLine)));
routeac->setPen(QPen(red,5,PenStyle(DashLine)));
routead->setPen(QPen(red,5,PenStyle(DashLine)));
routeba->setPen(QPen(green,5,PenStyle(SolidLine)));
routebb->setPen(QPen(green,5,PenStyle(DashLine)));
routebc->setPen(QPen(green,5,PenStyle(DashLine)));
routeca->setPen(QPen(blue,5,PenStyle(DashLine)));

routeac->setZ(0);
routead->setZ(0);
routeba->setZ(0);
routebb->setZ(0);
routeca->setZ(0);

youarehere = new QCanvasEllipse(20, 20, can);
youarehere->setX(365);youarehere->setY(460);
youarehere->setBrush(QBrush(red,SolidPattern ));
youarehere->setPen(QPen(green,5,PenStyle(NoPen)));
youarehere->show();

tekstyouarehere = new QCanvasText(tr("You are here"), can);
tekstyouarehere->setX(305);tekstyouarehere->setY(430);
tekstyouarehere->setColor(red);
tekstyouarehere->show();

thewinneris = new QCanvasText(tr("The winner!"), can);
thewinneris->setX(680);thewinneris->setY(555);
thewinneris->setColor(red);
thewinneris->hide();

	QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
	QString pictureairplane,desert_landscape,picture_train,picture_men,roeiboot;
	pictureairplane.append(appBaseDir);
	desert_landscape.append(appBaseDir);
	picture_train.append(appBaseDir);
	picture_men.append(appBaseDir);
	roeiboot.append(appBaseDir);
	pictureairplane.append("pictures/airplane.png");
	desert_landscape.append("pictures/desert_landscape2.jpg");
	picture_train.append("pictures/train.png");
	picture_men.append("pictures/man.png");
	
	pixarrayairplane = new QCanvasPixmapArray(pictureairplane,0);  
	qcanvasspriteairplane = new QCanvasSprite(pixarrayairplane, can);
	qcanvasspriteairplane->move(20,340,5);
	qcanvasspriteairplane->show();

	pixarraytrain = new QCanvasPixmapArray(picture_train,1);  
	qcanvasspritetrain = new QCanvasSprite(pixarraytrain, can);
	qcanvasspritetrain->move(300,500,3);
	qcanvasspritetrain->show();
		
	pixarrayman = new QCanvasPixmapArray(picture_men,1);
	qcanvasspriteman1 = new QCanvasSprite(pixarrayman, can);
	qcanvasspriteman1->move(343,420,10);
	qcanvasspriteman1->hide();
	qcanvasspriteman2 = new QCanvasSprite(pixarrayman, can);
	qcanvasspriteman2->move(343,420,10);
	qcanvasspriteman2->hide();
	qcanvasspriteman3 = new QCanvasSprite(pixarrayman, can);
	qcanvasspriteman3->move(343,420,10);
	qcanvasspriteman3->hide();

	qcanvasspriteairplane->setZ(10);
	qcanvasspritetrain->setZ(10);
	qcanvasspriteman1->setZ(10);
	qcanvasspriteman2->setZ(10);
	qcanvasspriteman3->setZ(10);

realtimer = new QTimer( this );
connect( realtimer, SIGNAL(timeout()), this, SLOT(whattodowhenanimation()) );
stoptimer = new QTimer( this );
connect( stoptimer, SIGNAL(timeout()), this, SLOT(stopthetimer()) );
routetimer = new QTimer( this );
connect( routetimer, SIGNAL(timeout()), this, SLOT(drawingroutes()) );
}

void dWidgeta::drawingroutes()
{
counter++;
if (counter < 265) {routeaa->show(); routeaa->setPoints(365,460,365-counter,460);}
if (counter > 265){if (counter <590){ routeab->show();routeab->setPoints(100,460,100,460-(counter-265)); }}
if (counter > 590){if (counter <1190){ routeac->show();routeac->setPoints(100,135,(counter-590)+100,135); }}
if (counter >1190){if (counter <1430){ routead->show();routead->setPoints(700,135,700,(counter-1190)+135);}}
if (counter >1430){if (counter <1510){ routeba->show();routeba->setPoints(365,460,365-(counter-1430),460);}}
if (counter >1510){if (counter <1570){ routebb->show();routebb->setPoints(285,460,285,470+(counter-1510));}}
if (counter >1570){if (counter <1980){ routebc->show();routebc->setPoints(285,530,285+(counter-1570),530);}}
if (counter >1980){if (counter <2270){ routeca->show();routeca->setPoints(365,460,365+(counter-1980),460);}}
can->update();
if (counter >2270)stopthetimer();

}

void dWidgeta::drawroutes(int speed)
{
counter = 0;routetimer->start( speed, FALSE ); 
//stoptimer->start( 13000, TRUE ); 

/**INFO: USED VALUES routeaa->setPoints(365,460,60,460);routeaa->show();
routeab->setPoints(60,460,60,135);routeab->show();
routeac->setPoints(60,135,700,135);routeac->show();
routead->setPoints(700,135,700,520);routead->show();
+ moved the red line 40 to the left*/

/**INFO: USED VALUES 
routeba->setPoints(365,460,285,460);routeba->show();
routebb->setPoints(285,460,285,520);routebb->show();
routebc->setPoints(285,520,700,520);routebc->show();
*/
/**INFO: USED VALUES 
routeca->setPoints(365,460,630,460);routeca->show();
*/
}

void dWidgeta::animation()
{
qcanvasspriteman1->show();
qcanvasspriteman2->show();
qcanvasspriteman3->show();
movement = 0;counter = 0;
realtimer->start( 10, FALSE ); 
//stoptimer->start( 32000, TRUE ); 

}

void dWidgeta::whattodowhenanimation()
{
counter++; 
if (movement >5 ) {movement = 0;}
//AIRPLANE
if (counter >5*400) {if (counter < 4*400+640) {double q =qcanvasspriteairplane->y(); q--;  qcanvasspriteairplane->setY( q);}}
if (counter >1600+640) {if (counter<1600+1280) {double q =qcanvasspriteairplane->x(); q++;  qcanvasspriteairplane->setX( q);}}
if (counter >1600+1280) {if (counter <1600+1440+50){double q =qcanvasspriteairplane->y(); q++;  qcanvasspriteairplane->setY( q);}}
if (counter == 1600+1440+80) {qcanvasspriteman1->move(710,290,10);qcanvasspriteman1->setZ(11);qcanvasspriteman1->show();}
if (counter > 3120) stopthetimer();
if(movement != 1)
{
//TRAIN
if(movement !=2)
{
if(counter > 5*144) {if (counter<634+288+268) {double q =qcanvasspritetrain->x(); q++;  qcanvasspritetrain->setX( q);}}
if(counter >= 634+288+268) {qcanvasspriteman3->move(690,480,10);qcanvasspriteman3->show();thewinneris->show();}
}
}
//PEDESTRIAN
if(movement == 1)
{
if (counter < 5*280+180) {double q = qcanvasspriteman2->x(); q++; qcanvasspriteman2->setX(q);}
if (counter < 5*80) {double q = qcanvasspriteman3->x(); q--; qcanvasspriteman3->setX(q);}
if (counter > 5*80) {  if (counter <5*140) {double q = qcanvasspriteman3->y(); q++; qcanvasspriteman3->setY(q);}}
if (counter >= 5*140) {if (counter< 634+288+288){ qcanvasspriteman3->hide();}}
if (counter< 5*300) {double q = qcanvasspriteman1->x(); q--; qcanvasspriteman1->setX(q);}
if (counter> 5*300) {if(counter <5*400){double q = qcanvasspriteman1->y(); q--; qcanvasspriteman1->setY(q);}}
if (counter>=5*400) {if (counter < 6*400) {qcanvasspriteman1->hide();}}

}
movement++;
can->update();
}

void dWidgeta::stopthetimer()
{
 if ( realtimer->isActive() )realtimer->stop();
 if ( routetimer->isActive() )routetimer->stop();
next();
}

void dWidgeta::updatecanvas()
{	
	if (number>=5){number=0; removeall();tekstyouarehere->show();tekstinfo->setText(tr("Welcome,\n\n3 Persons are in the middle of the desert. They are thirsty and want to go to the oasis as fast as possible. Wich way is the fastest way? \nPress 'next' to view the 3 possible ways."));nextbutton->show();}
	if(number==1){ nextbutton->hide();tekstinfo->setText(tr("Busy...drawing the possible routes..."));drawroutes(5);/**the larger the number is, the lower the speed*/;}
	if (number == 2) {tekstinfo->setText(tr("The airplane is the fastest, but the airport is far away. When travelling by foot you can take the shortest way, but it's very slow...and travelling by train?\nThe persons split upt. Who will be the first to reach the oasis?\nClick 'next' to find out."));  nextbutton->show();}
	if (number == 3) {nextbutton->hide();tekstyouarehere->hide();tekstinfo->setText(tr("Showing the animation..."));nextbutton->hide();animation(); } 
	if (number == 4) {tekstinfo->setText(tr("You saw that the person travelling by train reach the oasis first.  Despite not taking the shortest way...."));nextbutton->show();}  
	
	can->setAllChanged();
	can->update();
}

void dWidgeta::makecanvas()
{
	QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
	QString desert_landscape;
	desert_landscape.append(appBaseDir);
	desert_landscape.append("pictures/desert_landscape2.jpg");
		
	can = new QCanvas(this,"can");
    	can->resize(1100,815);
	can->setBackgroundColor(QColor(233,216,171));
     	canview = new QCanvasView(can,this,"canview");
	QPixmap jan(desert_landscape, "JPEG", 0); //backgrounds
	can->setBackgroundPixmap(jan);
	makeobjects();
}

void dWidgeta::doupdate()
{
can->setAllChanged();
can->update();
}

void dWidgeta::removeall()
{
routeaa->hide();
routeab->hide();
routeac->hide();
routead->hide();
routeba->hide();
routebb->hide();
routebc->hide();
routeca->hide();
thewinneris->hide();
qcanvasspriteman1->move(343,420,10);
qcanvasspriteman1->hide();
qcanvasspriteman2->move(343,420,10);
qcanvasspriteman2->hide();
qcanvasspriteman3->move(343,420,10);
qcanvasspriteman3->hide();
qcanvasspriteairplane->move(20,340,5);
qcanvasspritetrain->move(300,500,3);
can->update();
}


void dWidgeta::makebuttons()
{
	nextbutton = new QPushButton( tr("&Next"), this, "nextbutton" );
   	nextbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	nextbutton->setFixedWidth(170);
	
	tostartbutton = new QPushButton( tr("To &Start"), this, "tostartbutton" );
   	tostartbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	tostartbutton->setFixedWidth(170);
	
	connect( nextbutton, SIGNAL(clicked()), this , SLOT(next()) );
	connect( tostartbutton, SIGNAL(clicked()), this , SLOT(tostart()) );
}

void dWidgeta::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	onderaan = new QHBoxLayout;
}

void dWidgeta::addlayouts()
{
	grid->addMultiCellLayout(onderaan,2, 2, 1,2);
	grid->addLayout(info, 1 , 1);
	grid->addLayout(canvas, 1,2);
	grid->setColStretch( 2, 10 );
}

void dWidgeta::maketekstinfo()
{
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setText(tr("Welcome,\n\n3 Persons are in the middle of the desert. They are thirsty and want to go to the oasis as fast as possible. Wich way is the fastest way? \nPress 'next' to view the 3 possible ways."));nextbutton->show();
}

void dWidgeta::allesingrid()
{
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	onderaan->addStretch( 1 );
	onderaan->addWidget(tostartbutton);
	onderaan->addWidget(nextbutton);
}
