#ifndef SHELL_H
#define  SHELL_H

/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 #include <qtextcodec.h>
 #include <qtranslator.h> 
#include <qmainwindow.h> 
#include <qapplication.h>
#include "amainwindow.h"
#include "bmainwindow.h"
#include "cmainwindow.h"
#include "dmainwindow.h"
#include "startwindow.h"
#include <qpushbutton.h>
#include <qpopupmenu.h> 
#include <qmenubar.h> 
#include "about.h"
 #include <kapplication.h> 
 #include <kcmdlineargs.h> 
 #include <kaboutdata.h> 
#include <kglobal.h>
#include <klocale.h>

 
class Shell: public QMainWindow 
{
	Q_OBJECT
public:
	Shell( QWidget *parent, const char *name, WFlags f);	
	~Shell();
	  
	void makemenustructure();
	void makestartpage();
	  
	  Mainwindowa *amainwindow; //vanuit de file  #include "amainwindow.h" --> sorry voor verwarrende notatie
	  Mainwindowb *bmainwindow;
	  Mainwindowc *cmainwindow;
	  Mainwindowd *dmainwindow;
	  
	  StartPage *startpage; //vanuit file "startwindow.h" -> 1e widget die te zien is
	  	  
	  int previouswidget;
	  	  
	  QPopupMenu *help ;
	  QPopupMenu *bestand;
	  QPopupMenu *nieuw;
	  Aboutdialog *aboutdialog;
public slots:
void about();
void setoptica();
void setdeelverhouding();
void setarchimedes();
void setextremaprobs();
void removeoldwidgets();
void setstartpage();
};
#endif // SHELL_H
