/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THEORY_H
#define THEORY_H
 #include <qtextcodec.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qfont.h>
#include <qlayout.h>

#include <qmime.h> 

#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
 #include <qdir.h>
//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 

#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>
/**
@author Toon Muylkens
*/
class Theory : public QWidget
{
Q_OBJECT
public:
    Theory(QWidget *parent = 0, const char *name = 0, QString pathplace = 0);

    ~Theory();
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void allesingrid(); // plaats alles in de grid
	void maketekstinfo(QString pathplace);
			
	QGridLayout *grid;
//	QHBoxLayout *layoutonder;
	QVBoxLayout *info;
	QVBoxLayout *theorie;
	
	//QHBoxLayout *layoutonder;
	
				
	//QPushButton *quit;
		
	QTextBrowser *tekstinfoleft;
	QTextBrowser *tekstinforight;
	
	QMimeSourceFactory *tempsource;
};

#endif
