#ifndef AWIDGETA_H
#define  AWIDGETA_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>

#include <qcanvas.h>

#include <qcolor.h> 
 #include <qdir.h>
#include <qlabel.h> 
#include <math.h>
#include <qlineedit.h> 
#include <qmessagebox.h> 
#include <qpixmap.h>
#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 

/*KDE header files*/
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class Widgeta: public QWidget
{
	Q_OBJECT
public:
	Widgeta( QWidget *parent, const char *name);	
	~Widgeta();
	
	int number; // hoe vaak al next gedrukt?
	
	void setstandards(); //zet standaard values
	void makebuttons(); //buttons worden er aangemaakt en geconnect!
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	void makelines(); //maak de lijnen
	void drawlines(QCanvasLine *lijn, int xa, int ya, int xb, int yb);
	void removealllines(); //wil je de tutorial opnieuw doen dan moeten eerst alle lijnen gedelete worden. coordinaten op 00 zetten fzo? anders setvisible(false)
		
	QGridLayout *grid;
	
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	//QHBoxLayout *bovenaan;
	QHBoxLayout *onderaan;
	
	QCanvas *can;
    	QCanvasView *canview;
    	//QPushButton *quit;
	QPushButton *nextbutton;
	QPushButton *tostartbutton;
	
	QCanvasLine *linea;
	QCanvasLine *lineb;
	QCanvasLine *linec;
	QCanvasLine *lined;
	QCanvasLine *linee;
	
	
	QLabel *labelinfo;	
	
	QMimeSourceFactory *mimesource;
	QTextBrowser *tekstinfo;
	
	//NEW FEATURES
	//fish
	
	/*QCanvasPixmap *qcanvasfishb;
	QCanvasSprite *qcanvassprite;
	QCanvasPixmapArray *pixarray;
	
	//tabs
	QTabBar *tabbar;
	*/
	QCanvasPixmapArray *pixarraywater;
	QCanvasSprite *qcanvasspritewater;
	
//public slots:
private slots:
	void next();
	void tostart();
};
#endif // AWIDGETA_H
