/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LCDRANGE_H
#define LCDRANGE_H
#include <qlabel.h> 
//#include <qlayout.h>
#include <qvbox.h>

class QSlider;


class LCDRange : public QVBox
{
    Q_OBJECT
public:
    QLabel *label;
//    QGridLayout *gridlcd;
//	QVBoxLayout *boxlcd;
    LCDRange(const char *inhoud=0, QWidget *parent=0, const char *name=0 );
    int value() const;
    
    QSlider  *slider;
    
public slots:
    void setValue( int );
    void setRange( int minVal, int maxVal );
    
signals:
    void valueChanged( int );
	

};


#endif // LCDRANGE_H

