/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "startwindow.h"

#include <qvariant.h>
#include <qtextbrowser.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <stdio.h>
#include <iostream>
using namespace std;

StartPage::StartPage( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name ) setName( "startwindow" );
    StartPageLayout = new QHBoxLayout( this, 11, 6, "StartPageLayout");

    
QString locale_small;
locale_small=QTextCodec::locale();
locale_small.setLength(2);
// not nl ru fr en => en
int a = 0;
if (locale_small == "ru") a =1;
if (locale_small == "nl") a =1;
if (locale_small == "gl") a =1;
if (locale_small == "fr") a =1;
/** Jos, uncomment the following line to use spanish translations*/
//if (locale_small == "es") a =1;
if (locale_small == "en") a =1;
if (a != 1) locale_small="en";
//end
QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
QString startpageurl;
startpageurl.append(appBaseDir);
startpageurl.append("html_pages/startpage_");
startpageurl.append(locale_small);
startpageurl.append(".html");

//cout <<"locale small"<< locale_small<<endl;


    
    textBrowser1 = new QTextBrowser( this, "textBrowser1" );
    QString startpage;
      textBrowser1->setFrameShadow(QFrame::Raised);
    textBrowser1->setFrameShape(QFrame::StyledPanel);
//     textBrowser1->setLineWidth(4);
//     textBrowser1->setMidLineWidth(40);
    textBrowser1->setSource(startpageurl);
    
    StartPageLayout->addWidget( textBrowser1 );
    //resize( QSize(600, 480).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

StartPage::~StartPage()
{
}
